#include "Messages.h"

namespace RoboidControl {

/// @brief A message communicating the network ID for that participant
class SiteMsg : public IMessage {
public:
  /// @brief The message ID
  static const unsigned char id = 0xA1;
  /// @brief The length of the message
  static const unsigned char length = 2;
  /// @brief The network ID for the participant
  unsigned char networkId;

  /// @brief Create a new message for sending
  /// @param networkId The network ID for the participant
  SiteMsg(unsigned char networkId);
  /// @copydoc RoboidControl::IMessage::IMessage(char*)
  SiteMsg(const char *buffer);
  /// @brief Destructor for the message
  virtual ~SiteMsg();

  /// @copydoc RoboidControl::IMessage::Serialize
  virtual unsigned char Serialize(char *buffer) override;
};

} // namespace Control
